import java.applet.*;
import java.awt.*;
import java.net.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

public class EX23D extends Applet
{
	Recordset recordset;
	TextArea output;
	Database db;

	public void init()
	{
		resize(500, 400);
		output = new TextArea(20, 50);
		add(output);
	}

	public void start()
	{
		OpenDatabase();
	}
		
	public void stop()
	{
		// Close the recordset and database
		recordset.Close();
		db.Close();
	}

	private boolean OpenDatabase()
	{
		URL dbURL;
		try {
			// otherwise generate it relative to the applet
			dbURL = new java.net.URL(getDocumentBase(), "sample.mdb");
		}
		catch(Exception e) {
			showStatus("Error: " + e.getMessage());
			return false;
		}

		// strip "file:/" from dbURL
		String filename = dbURL.getFile().substring(1);

		// create the database engine
		_DBEngine idbengine = dao_dbengine.create();

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var1 = new Variant();
		Variant var2 = new Variant();
		Variant var3 = new Variant();

		// set parameters for call to OpenDatabase
		var1.putBoolean(false);
		var2.putBoolean(false);
		var3.putString("");

		// Open the database for non-exclusive access
		db = idbengine.OpenDatabase(filename, var1, var2, var3);

		// create Variants that will hold parameters that will be
		// passed to OpenDatabase
		Variant var4 = new Variant();
		Variant var5 = new Variant();

		var4.putShort(Constants.dbOpenTable);
		var5.putShort(Constants.dbEditAdd);

		// create the recordset
		recordset = db.OpenRecordset("Programmer", var4, var5);

		// give a bonus to all the Java programmers
		AddNewHire();

		// display all programmers to verify the new hire
		DisplayAllRecords();

		return true;
	}

	private void AddNewHire()
	{
		// create a variant for each column
		Variant varFirstName = new Variant();
		Variant varLastName = new Variant();
		Variant varSalary = new Variant();
		Variant varKnowsJava = new Variant();
		Variant varJobTitle = new Variant();

		// set the name of each column
		varFirstName.putString("FirstName");
		varLastName.putString("LastName");
		varSalary.putString("Salary");
		varKnowsJava.putString("KnowsJava");
		varJobTitle.putString("JobTitle");

		// tell the recordset its about to get a new record
		recordset.AddNew();

		// retrieve the fields for this recordset
		Fields fields = recordset.getFields();
		_Field fld;

		// create a Variant to hold temporary values
		Variant value = new Variant();

		// set the FirstName field
		fld = fields.getItem(varFirstName);
		value.putString("Napoleon");
		fld.putValue(value);

		// set the LastName field
		fld = fields.getItem(varLastName);
		value.putString("Solo");
		fld.putValue(value);

		// set the Salary field
		fld = fields.getItem(varSalary);
		value.putInt(63000);
		fld.putValue(value);

		// set the KnowsJava field
		fld = fields.getItem(varKnowsJava);
		value.putBoolean(true);
		fld.putValue(value);

		// set the JobTitle field
		fld = fields.getItem(varJobTitle);
		value.putString("Lead Programmer");
		fld.putValue(value);

		// commit the new record to the recordset
		recordset.Update();
	}

	private void DisplayAllRecords()
	{
		// determine how many records in the recordset
		int count = recordset.getRecordCount();

		// create a variant for each column
		Variant varFirstName = new Variant();
		Variant varLastName = new Variant();
		Variant varSalary = new Variant();
		Variant varKnowsJava = new Variant();
		Variant varJobTitle = new Variant();

		// set the name of each column
		varFirstName.putString("FirstName");
		varLastName.putString("LastName");
		varSalary.putString("Salary");
		varKnowsJava.putString("KnowsJava");
		varJobTitle.putString("JobTitle");

		// position recordset at the first record
		recordset.MoveFirst();

		// loop through the recordset, displaying each record
		for(int recNum = 0; recNum < count; recNum++)
		{
			// get the fields in this recordset
			Fields fields = recordset.getFields();
			_Field fld;

			// create a Variant that will hold each the value
			// read from each column
			Variant value;

			// get the LastName field
			fld = fields.getItem(varLastName);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText(value.toString() + ", ");

			// get the FirstName field
			fld = fields.getItem(varFirstName);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText(value.toString() + "\r\n");

			// get the JobTitle field
			fld = fields.getItem(varJobTitle);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText("\t" + value.toString() + "\r\n");

			// get the Salary field
			fld = fields.getItem(varSalary);
			// get its value
			value = fld.getValue();
			// display the value
			output.appendText("\t" + value.toString() + "\r\n");

			// get the KnowsJava field
			fld = fields.getItem(varKnowsJava);
			// get its value
			value = fld.getValue();
			// display the value
			Boolean knowsJava = new Boolean (value.toBoolean());
			output.appendText("\tKnows Java: " + knowsJava.toString() + "\r\n");

			recordset.MoveNext();
		}
	}
}

